{                                                                             }
{       EGA Graphic Primitive for Turbo Pascal 3.01A, Version 01FEB86.        }
{       (C) 1986 by Kent Cedola, 2015 Meadow Lake Ct., Norfolk, VA, 23518     }
{                                                                             }
{       Description: The single point clip and scale routine is not a true    }
{       graphic primitive because in must be included with other code in a    }
{       procedure (or function).  The variables X1,Y1 and OUTSIDE must be     }
{       defined on the local stack and the window and viewport variables      }
{       are global (include file WORLD.P).                                    }
{                                                                             }

function GPCLIP2(var X1,Y1,X2,Y2: Integer): Integer;
begin
  inline
    ($55 /$C4/$7E/$10 /$26/$8B/$0D /$C4/$7E/$0C /$26/$8B/$1D /$C4/$7E/$08
      /$26/$8B/$35 /$C4/$7E/$04 /$26/$8B/$3D /$33/$C0 /$89/$46/$14 /$33/$C0
      /$3B/$1E/GDWD_Y1 /$7D/$03 /$80/$CC/$08 /$3B/$1E/GDWD_Y2 /$7E/$03
      /$80/$CC/$04 /$3B/$0E/GDWD_X1 /$7D/$03 /$80/$CC/$02 /$3B/$0E/GDWD_X2
      /$7E/$03 /$80/$CC/$01 /$3B/$3E/GDWD_Y1 /$7D/$02 /$0C/$08 /$3B/$3E/GDWD_Y2
      /$7E/$02 /$0C/$04 /$3B/$36/GDWD_X1 /$7D/$02 /$0C/$02 /$3B/$36/GDWD_X2
      /$7E/$02 /$0C/$01 /$0B/$C0 /$75/$03 /$E9/>$96 /$C6/$46/$14/$01 /$84/$E0
      /$74/$08 /$C6/$46/$14/$02 /$5D /$E9/>$A1 /$0A/$C0 /$75/$06 /$87/$CE
      /$87/$DF /$86/$E0 /$A8/$02 /$75/$24 /$A8/$04 /$75/$3C /$A8/$08 /$75/$54
      /$8B/$EF /$2B/$EB /$A1/GDWD_X2 /$2B/$C1 /$F7/$ED /$8B/$EE /$2B/$E9
      /$F7/$FD /$03/$C3 /$8B/$36/GDWD_X2 /$8B/$F8 /$E9/$FF71 /$8B/$EF /$2B/$EB
      /$A1/GDWD_X1 /$2B/$C1 /$F7/$ED /$8B/$EE /$2B/$E9 /$F7/$FD /$03/$C3
      /$8B/$36/GDWD_X1 /$8B/$F8 /$E9/$FF55 /$8B/$EE /$2B/$E9 /$A1/GDWD_Y2
      /$2B/$C3 /$F7/$ED /$8B/$EF /$2B/$EB /$F7/$FD /$03/$C1 /$8B/$F0
      /$8B/$3E/GDWD_Y2 /$E9/$FF39 /$8B/$EE /$2B/$E9 /$A1/GDWD_Y1 /$2B/$C3
      /$F7/$ED /$8B/$EF /$2B/$EB /$F7/$FD /$03/$C1 /$8B/$F0 /$8B/$3E/GDWD_Y1
      /$E9/$FF1D /$5D /$8B/$C7 /$C4/$7E/$10 /$26/$89/$0D /$C4/$7E/$0C
      /$26/$89/$1D /$C4/$7E/$08 /$26/$89/$35 /$C4/$7E/$04 /$26/$89/$05);
end;
