{                                                                              }
{       EGA Graphic Primitive for Turbo Pascal 3.01A, Version 01FEB86.         }
{       (C) 1986 by Kent Cedola, 2015 Meadow Lake Ct., Norfolk, VA, 23518      }
{                                                                              }
{       Description: Read the setting of the palette register.  This can       }
{       only be done if an EGA save area has been assigned, else -1 will       }
{       be returned.  Use the program 'KCSETPAL' to build save area.           }
{                                                                              }

function GPRDPAL(Palette: Integer): Integer;
begin
 inline
   ($33/$C0/$8E/$C0/$26/$C4/$1E/$04A8/$83/$C3/$04/$26/$C4/$1F/$8C/$C0/$0B/$C3/
    $74/$14/$8A/$46/<Palette/$3C/$FF/$75/$02/$B0/$11/$32/$E4/$03/$D8/$26/$8A/
    $07/$32/$E4/$EB/$03/$B8/$FFFF/$89/$46/$06);
end;
